/**
 * <h1>Clase que extiende de Pilot y define el algoritmo de otro piloto.</h1> 
 * Implementa constructores y mtodos necesarios para definir el algoritmo "pared 
 * a la izquierda" (avanza hasta que encuentra un pared a la izquierda y luego se 
 * mueve pegado a ella). 
 * 
 * @author Matas Contreras, Francisco Frez, Damin Quiroz.
 * @version 1.0
 * @since 2018-04-30
 */

public class MyPilot extends Pilot {
	/** Constructor base de la clase, se inicializan las variables creadas. */
    MyPilot(Robot in){
      super(in);
    }
    
	/**
	 * Mtodo que lleva a cabo el algoritmo de "pared a la izquierda".
	 * 
	 * @param delta_t:
	 * 			Variable del tipo double que define el tiempo al interior de 
	 * la simulacin (permite generacin de movimiento).
	 * 
	 * <b>Nota:</b> define una serie de variables auxiliares que sirven de
	 * apoyo para el cumplimiento de las mltiples condiciones implementadas. 
	 */
    public void setCourse(double delta_t){
        int lastR = (int)super.rRigth.getDistance();
        int lastF = (int)super.rForward.getDistance();
        int lastL = (int)super.rLeft.getDistance();
        
        /* Variables booleanas que permiten consultar el estado del robot */
        boolean PDer,PIzq,PFor,PLost,PFil,PMedR,PMedL,PMedF;

        PMedR = super.posRange.contains(lastR);
        PMedL = super.posRange.contains(lastL);
        PMedF = super.posRange.contains(lastF);

        PDer = ((PMedR) && !(PMedF) && !(PMedL));
        PIzq = (!(PMedR) && !(PMedF) && (PMedL));
        PFor = (!(PMedR) && (PMedF) && !(PMedL));
        PLost =(!(PMedR) && !(PMedF) && !(PMedL));
        PFil = (!(PMedR) && (PMedF) && (PMedL));
        
        /* Algoritmo para resolver el laberinto usando la pared 
         * izquierda como referencia */

        /* Primera condicin permite que los sensores del robot 
         * no sensen fuera del laberinto y adems que el robot no 
         * salga del laberinto */

        if(PDer || PFor || PFil ){
            super.stateCont = 0;
            super.robot.traceRoute();
            super.robot.turnRight();
        }else if(PIzq){
            super.stateCont = 0;
            super.robot.traceRoute();
            super.robot.moveDelta_t(delta_t);
        }  else if(PLost){
            super.robot.traceRoute();
            if(stateCont == 0)
                robot.turnLeft();
            else if(stateCont == 1 )
                robot.moveDelta_t(delta_t);
            else if(stateCont == 2)
                robot.turnRight();
            else if(stateCont == 3)
                robot.moveDelta_t(delta_t);
            else 
                System.err.println("Error de Sistema: Autodestruccin Inminente, Me Pase Poh!");
            
            stateCont = (stateCont+1)%4;
            
        /* Si entra en la condicin por defecto, quiere decir que 
         * se seteo el robot en un lugar indebido o est en una 
         * condicin no prevista. */ 
            
        } else {
            robot.traceRoute();
            robot.getPosition();
            System.err.println("Save me pls!");
        }
    }
}
